<?php
/**
 * The file that defines the languages
 *
 * @link       www.faboba.com
 * @since      1.0.0
 *
 * @package    Falang
 */

namespace Falang\Factory;

use Falang\Model\Falang_Model;
use Falang\Translator\TranslatorYandex;



class TranslatorFactory
{
	private static $translator;

	static public function getTranslator($target_language_locale)
	{
		if (translatorFactory::$translator != null)
		{
			return translatorFactory::$translator;
		}

		$falang_model = new Falang_Model();

		//TODO support only 1 transaltor service

		//$falang_model->get_option('translator');
		$translator_name = 'Yandex';

		$service    = 'Translator' . $translator_name;
		//$translator = new $service();
		$translator = new TranslatorYandex();

		$from = $translator->languageCodeToISO($falang_model->get_default_language()->locale);
		$to   = $translator->languageCodeToISO($target_language_locale);

		$translator->installScripts($from,$to);



		TranslatorFactory::$translator = $translator;

		return $translator;
	}
}